function BatchBuildIndex(MTS_D,UTS_D, Index_D, window_size, FeatureSet, Ref_D, num_ref)

% % This program builds the indices in a batch mode
% % Input: 
% %     MTS_D:        The input folder containing the MTS time series files
% %     UTS_D:        The folder where the univariate times series will be saved
% %     Index_D:      The folder where the indices will be saved
% %     window_size:  Size of sliding window (typically 256, 512 or 1024) 
% %     FeatureSet:   The ids of the features on which to build the index    
% %     Ref_D:        The folder where the reference points will be saved
% %     num_ref:      Number of reference points

Num_MTS = MTS2UTS(MTS_D,UTS_D,FeatureSet);
for i = 1:length(FeatureSet)
    GenerateRefPoints(UTS_D, Ref_D, num_ref, window_size,FeatureSet(i),Num_MTS);
    for ref_ind = 1:num_ref
        BuildIndex(UTS_D,Index_D,FeatureSet(i),window_size,Ref_D,ref_ind, Num_MTS);
    end
end