function GenerateQuery(UTS_D,Num_MTS,window_size,VariablePool,num_var,p,queryname)
% generate a random MTS query
% 'UTS_D' is the folder to store all UTS
% 'num_var' variables are chosen from 'VariablePool' (array)
% lenghth of ith query varibale = p(i)* window_size
% query will be save to the disk as 'queryname'


%% Pick variables for the query
SizePool = length(VariablePool);
variable_ind = ceil(rand(num_var,1)*SizePool);
%check whether there is any replication
for i = 2:num_var
    while ~isempty(find(variable_ind(i)==variable_ind(1:i-1), 1))
        variable_ind(i) = ceil(rand(1,1)*SizePool);
    end
end
variables = VariablePool(variable_ind); %pick variables


q = cell(num_var,1);
%p = ones(num_var,1); %lenghth of ith query varibale = p(i)* window_size, can be set by the user
%for the 1st varibale
rand_MTS_q  = ceil(rand(1,1)*Num_MTS);
filename = [UTS_D '\' num2str(variables(1)) '\' num2str(rand_MTS_q) '.txt'];
uts = load(filename);
rand_Offset_q  = ceil(rand(1,1) * (length(uts)-window_size*p(1)+1));
q{1} = uts(rand_Offset_q:rand_Offset_q+window_size*p(1)-1);
%for the remaining varibales, the offset is based on the previous variable
time_shiftings =  50 + ceil(rand(num_var-1,1)*50);
for i = 2:num_var
    rand_Offset_q  = rand_Offset_q + time_shiftings(i-1);
    filename = [UTS_D '\' num2str(variables(i)) '\' num2str(rand_MTS_q) '.txt'];
    uts = load(filename);
    if length(uts) < rand_Offset_q + window_size*p(i)-1
        disp('offset is too large for query'); return;
    end
    q{i} = uts(rand_Offset_q:rand_Offset_q+window_size*p(i)-1);
end


%save the query
save (queryname, 'q','p', 'variables', 'time_shiftings');