function mts_start_end = cluster_cand(cand)
% mts_start_end is a n*3 matrix
% a row [A B C] denotes candidates from mts A are from B to C in candidate set

MAX = 10000;
mts_start_end = zeros(MAX,3);

rows = size(cand,1);
num_mts = 0;
current_row = 1;
while current_row <= rows
    current_mts = cand(current_row,1);
    num_mts = num_mts + 1;
    mts_start_end(num_mts,1) = current_mts;
    mts_start_end(num_mts,2) = current_row;
    
    current_row = current_row + 1;
    while current_row <= rows && cand(current_row,1) == current_mts
        current_row = current_row + 1;
    end
    mts_start_end(num_mts,3) = current_row -1;
end

mts_start_end(num_mts+1:MAX,:) = [];